Index: /branches/2521_ProblemRefactoring/HeuristicLab.Analysis/3.3/MultiObjective/HypervolumeAnalyzer.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Analysis/3.3/MultiObjective/HypervolumeAnalyzer.cs	(revision 17225)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Analysis/3.3/MultiObjective/HypervolumeAnalyzer.cs	(revision 17225)
@@ -0,0 +1,84 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Linq;
+using HEAL.Attic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+
+namespace HeuristicLab.Analysis {
+  [StorableType("fc42ed56-15de-41df-bf59-0e5b11cd4f9b")]
+  [Item("HypervolumeAnalyzer", "Computes the enclosed Hypervolume between the current front and a given reference Point")]
+  public class HypervolumeAnalyzer : MultiObjectiveSuccessAnalyzer {
+    public override string ResultName {
+      get { return "Hypervolume"; }
+    }
+
+    public ILookupParameter<DoubleArray> ReferencePointParameter {
+      get { return (ILookupParameter<DoubleArray>)Parameters["ReferencePoint"]; }
+    }
+
+    public IResultParameter<DoubleValue> BestKnownHypervolumeResultParameter {
+      get { return (IResultParameter<DoubleValue>)Parameters["Best known hypervolume"]; }
+    }
+
+    public IResultParameter<DoubleValue> HypervolumeDistanceResultParameter {
+      get { return (IResultParameter<DoubleValue>)Parameters["Absolute Distance to BestKnownHypervolume"]; }
+    }
+
+
+    [StorableConstructor]
+    protected HypervolumeAnalyzer(StorableConstructorFlag _) : base(_) { }
+
+    protected HypervolumeAnalyzer(HypervolumeAnalyzer original, Cloner cloner) : base(original, cloner) { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new HypervolumeAnalyzer(this, cloner);
+    }
+
+    public HypervolumeAnalyzer() {
+      Parameters.Add(new LookupParameter<DoubleArray>("ReferencePoint", "The reference point for hypervolume calculation"));
+      Parameters.Add(new ResultParameter<DoubleValue>("Hypervolume", "The hypervolume of the current generation", "Results", new DoubleValue(double.NaN)));
+      Parameters.Add(new ResultParameter<DoubleValue>("Best known hypervolume", "The optimal hypervolume"));
+      Parameters.Add(new ResultParameter<DoubleValue>("Absolute Distance to BestKnownHypervolume", "The difference between the best known and the current hypervolume"));
+      BestKnownHypervolumeResultParameter.DefaultValue = new DoubleValue(double.NaN);
+      HypervolumeDistanceResultParameter.DefaultValue = new DoubleValue(double.NaN);
+    }
+
+    public override IOperation Apply() {
+      var qualities = QualitiesParameter.ActualValue.Select(x => x.CloneAsArray()).ToArray();
+      var referencePoint = ReferencePointParameter.ActualValue.ToArray();
+      var best = BestKnownHypervolumeResultParameter.ActualValue.Value;
+      var maximization = MaximizationParameter.ActualValue.ToArray();
+
+      var hv = HypervolumeCalculator.CalculateHypervolume(qualities, referencePoint, maximization);
+      if (hv > best || double.IsNaN(best)) best = hv;
+      ResultParameter.ActualValue.Value = hv;
+      BestKnownHypervolumeResultParameter.ActualValue.Value = best;
+      HypervolumeDistanceResultParameter.ActualValue.Value = best - hv;
+
+      return base.Apply();
+    }
+  }
+}
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Analysis/3.3/MultiObjective/InvertedGenerationalDistanceAnalyzer.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Analysis/3.3/MultiObjective/InvertedGenerationalDistanceAnalyzer.cs	(revision 17225)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Analysis/3.3/MultiObjective/InvertedGenerationalDistanceAnalyzer.cs	(revision 17225)
@@ -0,0 +1,58 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Linq;
+using HEAL.Attic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Analysis {
+  [StorableType("1004980a-9b3d-4b6f-b5bf-81e75d288344")]
+  [Item("InvertedGenerationalDistanceAnalyzer", "The inverted generational distance between the current and the best known front (see Multi-Objective Performance Metrics - Shodhganga for more information)")]
+  public class InvertedGenerationalDistanceAnalyzer : GenerationalDistanceAnalyzer {
+    public override bool EnabledByDefault {
+      get { return false; }
+    }
+    public override string ResultName {
+      get { return "Inverted Generational Distance"; }
+    }
+
+    public IResultParameter<DoubleValue> InvertedGenerationalDistanceResultParameter {
+      get { return (IResultParameter<DoubleValue>)Parameters["Inverted Generational Distance"]; }
+    }
+
+    [StorableConstructor]
+    protected InvertedGenerationalDistanceAnalyzer(StorableConstructorFlag _) : base(_) { }
+    protected InvertedGenerationalDistanceAnalyzer(InvertedGenerationalDistanceAnalyzer original, Cloner cloner) : base(original, cloner) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new InvertedGenerationalDistanceAnalyzer(this, cloner);
+    }
+
+    public InvertedGenerationalDistanceAnalyzer() : base() { }
+
+    protected override double CalculateDistance(ItemArray<DoubleArray> qualities, IEnumerable<double[]> optimalFront) {
+      return CalculateGenerationalDistance(optimalFront, qualities.Select(x => x.ToArray()), Dampening);
+    }
+  }
+}
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Analysis/3.3/MultiObjective/MultiObjectiveSuccessAnalyzer.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Analysis/3.3/MultiObjective/MultiObjectiveSuccessAnalyzer.cs	(revision 17225)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Analysis/3.3/MultiObjective/MultiObjectiveSuccessAnalyzer.cs	(revision 17225)
@@ -0,0 +1,61 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
+
+
+namespace HeuristicLab.Analysis {
+  [StorableType("3659291a-927c-4016-88be-8a0f65476660")]
+  public abstract class MultiObjectiveSuccessAnalyzer : SingleSuccessorOperator, IAnalyzer, IMultiObjectiveOperator {
+    public virtual bool EnabledByDefault {
+      get { return true; }
+    }
+    public abstract string ResultName { get; }
+
+    public IScopeTreeLookupParameter<DoubleArray> QualitiesParameter {
+      get { return (IScopeTreeLookupParameter<DoubleArray>)Parameters["Qualities"]; }
+    }
+
+    public ILookupParameter<BoolArray> MaximizationParameter {
+      get { return (ILookupParameter<BoolArray>)Parameters["Maximization"]; }
+    }
+
+    public ResultParameter<DoubleValue> ResultParameter {
+      get { return (ResultParameter<DoubleValue>)Parameters[ResultName]; }
+    }
+
+    protected MultiObjectiveSuccessAnalyzer(MultiObjectiveSuccessAnalyzer original, Cloner cloner) : base(original, cloner) { }
+    [StorableConstructor]
+    protected MultiObjectiveSuccessAnalyzer(StorableConstructorFlag _) : base(_) { }
+    protected MultiObjectiveSuccessAnalyzer() {
+      Parameters.Add(new ScopeTreeLookupParameter<DoubleArray>("Qualities", "The qualities of the parameter vector."));
+      Parameters.Add(new LookupParameter<DoubleMatrix>("BestKnownFront", "The currently best known Pareto front"));
+      Parameters.Add(new LookupParameter<BoolArray>("Maximization", ""));
+    }
+  }
+}
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Analysis/3.3/MultiObjective/SpacingAnalyzer.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Analysis/3.3/MultiObjective/SpacingAnalyzer.cs	(revision 17225)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Analysis/3.3/MultiObjective/SpacingAnalyzer.cs	(revision 17225)
@@ -0,0 +1,77 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HEAL.Attic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Analysis {
+  [StorableType("d84ac1f1-a6d4-425f-bcff-28472ef7529a")]
+  [Item("SpacingAnalyzer", "The spacing of the current front (see Multi-Objective Performance Metrics - Shodhganga for more information)")]
+  public class SpacingAnalyzer : MultiObjectiveSuccessAnalyzer {
+    public override string ResultName {
+      get { return "Spacing"; }
+    }
+
+    [StorableConstructor]
+    protected SpacingAnalyzer(StorableConstructorFlag _) : base(_) { }
+
+
+    protected SpacingAnalyzer(SpacingAnalyzer original, Cloner cloner) : base(original, cloner) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new SpacingAnalyzer(this, cloner);
+    }
+
+    public SpacingAnalyzer() {
+      Parameters.Add(new ResultParameter<DoubleValue>("Spacing", "The spacing of the current front", "Results", new DoubleValue(double.NaN)));
+    }
+
+    public override IOperation Apply() {
+      var qualities = QualitiesParameter.ActualValue;
+      ResultParameter.ActualValue.Value = CalculateSpacing(qualities.Select(x => x.ToArray()));
+      return base.Apply();
+    }
+
+    public static double CalculateSpacing(IEnumerable<double[]> qualities) {
+      if (qualities == null) throw new ArgumentNullException("qualities");
+      var l = qualities.ToList();
+      if (l.Count == 0) throw new ArgumentException("Front must not be empty.");
+      if (l.Count == 1) return 0;
+
+      var mat = l.ToMatrix();
+      alglib.kdtree tree;
+      alglib.kdtreebuild(mat, mat.GetLength(0), mat.GetLength(1), 0, 2, out tree);
+      var summand = new double[2];
+      var dists = new List<double>();
+      foreach (var point in l) {
+        alglib.kdtreequeryknn(tree, point.ToArray(), 2, true);
+        alglib.kdtreequeryresultsdistances(tree, ref summand);
+        dists.Add(summand[1]);
+      }
+      return dists.StandardDeviationPop();
+    }
+  }
+}
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Analysis/3.3/MultiObjective/TimelineAnalyzer.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Analysis/3.3/MultiObjective/TimelineAnalyzer.cs	(revision 17225)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Analysis/3.3/MultiObjective/TimelineAnalyzer.cs	(revision 17225)
@@ -0,0 +1,97 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
+
+namespace HeuristicLab.Analysis {
+  [StorableType("48fc7ff7-a8ab-4ef9-8c01-cc6fbbe3da0b")]
+  [Item("TimelineAnalyzer", "Collects the specified double values from the results and displays them as a timeline")]
+  public class TimelineAnalyzer : SingleSuccessorOperator, IAnalyzer, IMultiObjectiveOperator {
+    public bool EnabledByDefault {
+      get { return true; }
+    }
+    public string ResultName {
+      get { return "Timeline"; }
+    }
+
+    public IFixedValueParameter<CheckedItemList<StringValue>> CollectedSuccessMeasuresParameter {
+      get { return (IFixedValueParameter<CheckedItemList<StringValue>>)Parameters["CollectedSuccessMeasures"]; }
+    }
+
+    public ILookupParameter<ResultCollection> ResultsParameter {
+      get { return (ILookupParameter<ResultCollection>)Parameters["Results"]; }
+    }
+
+    public ResultParameter<DataTable> ResultParameter {
+      get { return (ResultParameter<DataTable>)Parameters[ResultName]; }
+    }
+
+    public CheckedItemList<StringValue> CollectedSuccessMeasures {
+      get { return CollectedSuccessMeasuresParameter.Value; }
+    }
+
+    [StorableConstructor]
+    protected TimelineAnalyzer(StorableConstructorFlag _) : base(_) { }
+
+
+    protected TimelineAnalyzer(TimelineAnalyzer original, Cloner cloner) : base(original, cloner) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new TimelineAnalyzer(this, cloner);
+    }
+
+    public TimelineAnalyzer() {
+      var names = new List<string> {
+        new CrowdingAnalyzer().ResultName,
+        new GenerationalDistanceAnalyzer().ResultName,
+        new InvertedGenerationalDistanceAnalyzer().ResultName,
+        new HypervolumeAnalyzer().ResultName,
+        new SpacingAnalyzer().ResultName
+      };
+      var analyzers = new CheckedItemList<StringValue>(names.Select(n => new StringValue(n)));
+      Parameters.Add(new FixedValueParameter<CheckedItemList<StringValue>>("CollectedSuccessMeasures", analyzers));
+      Parameters.Add(new LookupParameter<ResultCollection>("Results"));
+      Parameters.Add(new ResultParameter<DataTable>("Timeline", "The development of the success measures over the generations", "Results", new DataTable("Timeline", "")));
+    }
+
+    public override IOperation Apply() {
+      if (ResultParameter.ActualValue == null) ResultParameter.ActualValue = new DataTable(ResultName, "");
+      var plot = ResultParameter.ActualValue;
+      var resultCollection = ResultsParameter.ActualValue;
+      foreach (var resultName in CollectedSuccessMeasures.CheckedItems.Select(i => i.Value.Value)) {
+        if (!resultCollection.ContainsKey(resultName)) continue;
+        var res = resultCollection[resultName].Value as DoubleValue;
+        if (res == null) continue;
+        if (!plot.Rows.ContainsKey(resultName)) plot.Rows.Add(new DataRow(resultName));
+        plot.Rows[resultName].Values.Add(res.Value);
+      }
+      return base.Apply();
+    }
+  }
+}
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Common/3.3/EnumerableExtensions.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Common/3.3/EnumerableExtensions.cs	(revision 17224)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Common/3.3/EnumerableExtensions.cs	(revision 17225)
@@ -26,4 +26,28 @@
 namespace HeuristicLab.Common {
   public static class EnumerableExtensions {
+    public static T[,] ToMatrix<T>(this IEnumerable<IEnumerable<T>> source) {
+      if (source == null) throw new ArgumentNullException("source");
+      if (!source.Any()) return new T[0, 0];
+
+      int firstDimension = source.Count();
+      int secondDimension = source.First().Count();
+      var result = new T[firstDimension, secondDimension];
+
+      int i = 0;
+      int j = 0;
+      foreach (var row in source) {
+        j = 0;
+        foreach (var element in row) {
+          result[i, j] = element;
+          j++;
+        }
+        if (j != secondDimension) throw new InvalidOperationException("All enumerables must be of the same length.");
+        i++;
+      }
+
+      return result;
+    }
+
+
     /// <summary>
     /// Selects all elements in the sequence that are maximal with respect to the given value.
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/Interfaces/IValueTypeArray.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/Interfaces/IValueTypeArray.cs	(revision 17224)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/Interfaces/IValueTypeArray.cs	(revision 17225)
@@ -1,4 +1,3 @@
 ﻿#region License Information
-
 /* HeuristicLab
  * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
@@ -19,5 +18,4 @@
  * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
  */
-
 #endregion
 
@@ -47,8 +45,6 @@
 
   [StorableType("f9db5740-1c4f-4f62-a9a8-84b32a461ea8")]
-  public interface IValueTypeArray<T> : IValueTypeArray, IEnumerable<T> where T : struct {
-    T this[int index] { get; set; }
+  public interface IValueTypeArray<out T> : IValueTypeArray, IReadOnlyList<T> where T : struct {
+    //T this[int index] { get; set; }
   }
 }
-
-
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/ValueTypeArray.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/ValueTypeArray.cs	(revision 17224)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/ValueTypeArray.cs	(revision 17225)
@@ -76,4 +76,9 @@
     }
 
+    public int Count
+    {
+      get { return Length; }
+    }
+
     [Storable]
     protected bool resizable = true;
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.LinearLinkageEncoding/3.4/LinearLinkageMultiObjectiveProblem.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.LinearLinkageEncoding/3.4/LinearLinkageMultiObjectiveProblem.cs	(revision 17224)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.LinearLinkageEncoding/3.4/LinearLinkageMultiObjectiveProblem.cs	(revision 17225)
@@ -64,5 +64,5 @@
       base.Analyze(individuals, qualities, results, random);
 
-      var result = DominationCalculator<LinearLinkage>.CalculateBestParetoFront(individuals, qualities, Maximization);
+      var result = DominationCalculator.CalculateBestParetoFront(individuals, qualities, Maximization);
       // TODO: Add results
     }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Optimization.Operators/3.3/MultiObjective/CrowdingDistanceAssignment.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Optimization.Operators/3.3/MultiObjective/CrowdingDistanceAssignment.cs	(revision 17224)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Optimization.Operators/3.3/MultiObjective/CrowdingDistanceAssignment.cs	(revision 17225)
@@ -34,5 +34,4 @@
   [StorableType("F7DF8B74-F1E6-45D6-A1A8-5D381F20B382")]
   public class CrowdingDistanceAssignment : SingleSuccessorOperator, IMultiObjectiveOperator {
-
     public ScopeTreeLookupParameter<DoubleArray> QualitiesParameter {
       get { return (ScopeTreeLookupParameter<DoubleArray>)Parameters["Qualities"]; }
@@ -66,58 +65,12 @@
 
     public static void Apply(DoubleArray[] qualities, DoubleValue[] distances) {
-      int populationSize = qualities.Length;
-      int objectiveCount = qualities[0].Length;
-      for (int m = 0; m < objectiveCount; m++) {
-        Array.Sort<DoubleArray, DoubleValue>(qualities, distances, new QualitiesComparer(m));
-
-        distances[0].Value = double.MaxValue;
-        distances[populationSize - 1].Value = double.MaxValue;
-
-        double minQuality = qualities[0][m];
-        double maxQuality = qualities[populationSize - 1][m];
-        for (int i = 1; i < populationSize - 1; i++) {
-          distances[i].Value += (qualities[i + 1][m] - qualities[i - 1][m]) / (maxQuality - minQuality);
-        }
-      }
+      var dist = CrowdingCalculator.CalculateCrowdingDistances(qualities.Select(x => x.ToArray()).ToArray());
+      for (var i = 0; i < distances.Length; i++) distances[i].Value = dist[i];
     }
 
     public override IOperation Apply() {
-      DoubleArray[] qualities = QualitiesParameter.ActualValue.ToArray();
-      int populationSize = qualities.Length;
-      DoubleValue[] distances = new DoubleValue[populationSize];
-      for (int i = 0; i < populationSize; i++)
-        distances[i] = new DoubleValue(0);
-
-      CrowdingDistanceParameter.ActualValue = new ItemArray<DoubleValue>(distances);
-
-      Apply(qualities, distances);
-
+      var dist = CrowdingCalculator.CalculateCrowdingDistances(QualitiesParameter.ActualValue.Select(x => x.ToArray()).ToArray());
+      CrowdingDistanceParameter.ActualValue = new ItemArray<DoubleValue>(dist.Select(d => new DoubleValue(d)));
       return base.Apply();
-    }
-
-    private void Initialize(ItemArray<DoubleValue> distances) {
-      for (int i = 0; i < distances.Length; i++) {
-        if (distances[i] == null) distances[i] = new DoubleValue(0);
-        else distances[i].Value = 0;
-      }
-    }
-
-    [StorableType("30fd1927-b268-4ce7-8960-b04bfa83f1e6")]
-    private class QualitiesComparer : IComparer<DoubleArray> {
-      private int index;
-
-      public QualitiesComparer(int index) {
-        this.index = index;
-      }
-
-      #region IComparer<DoubleArray> Members
-
-      public int Compare(DoubleArray x, DoubleArray y) {
-        if (x[index] < y[index]) return -1;
-        else if (x[index] > y[index]) return +1;
-        else return 0;
-      }
-
-      #endregion
     }
 
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Optimization.Operators/3.3/MultiObjective/FastNonDominatedSort.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Optimization.Operators/3.3/MultiObjective/FastNonDominatedSort.cs	(revision 17224)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Optimization.Operators/3.3/MultiObjective/FastNonDominatedSort.cs	(revision 17225)
@@ -74,5 +74,5 @@
 
       int[] rank;
-      var fronts = DominationCalculator<IScope>.CalculateAllParetoFronts(scope.SubScopes.ToArray(), qualities, maximization, out rank, dominateOnEqualQualities);
+      var fronts = DominationCalculator.CalculateAllParetoFronts(scope.SubScopes.ToArray(), qualities, maximization, out rank, dominateOnEqualQualities);
 
       RankParameter.ActualValue = new ItemArray<IntValue>(rank.Select(x => new IntValue(x)));
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/IMultiObjectiveProblem.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/IMultiObjectiveProblem.cs	(revision 17224)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/IMultiObjectiveProblem.cs	(revision 17225)
@@ -1,4 +1,3 @@
 ﻿#region License Information
-
 /* HeuristicLab
  * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
@@ -19,12 +18,16 @@
  * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
  */
-
 #endregion
 
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
 namespace HeuristicLab.Optimization {
-  public interface IMultiObjectiveProblem<TEncoding, TEncodedSolution> : IProblem<TEncoding, TEncodedSolution>, IMultiObjectiveHeuristicOptimizationProblem
-    where TEncoding : class, IEncoding<TEncodedSolution>
-    where TEncodedSolution : class, IEncodedSolution {
+  public interface IMultiObjectiveProblem : IProblem, IMultiObjectiveHeuristicOptimizationProblem {
 
   }
+
+  public interface IMultiObjectiveProblem<TEncoding, TEncodedSolution> : IMultiObjectiveProblem, IProblem<TEncoding, TEncodedSolution>
+    where TEncoding : class, IEncoding<TEncodedSolution>
+    where TEncodedSolution : class, IEncodedSolution { }
 }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/IMultiObjectiveProblemDefinition.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/IMultiObjectiveProblemDefinition.cs	(revision 17224)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/IMultiObjectiveProblemDefinition.cs	(revision 17225)
@@ -20,15 +20,22 @@
 #endregion
 
+using System.Collections;
+using System.Collections.Generic;
 using HEAL.Attic;
 using HeuristicLab.Core;
+using HeuristicLab.Data;
 
 namespace HeuristicLab.Optimization {
+  public interface IMultiObjectiveProblemDefinition {
+    int Objectives { get; }
+    bool[] Maximization { get; }
+    IReadOnlyList<double[]> BestKnownFront { get; }
+    double[] ReferencePoint { get; }
+  }
+
   [StorableType("39eacdb5-80a0-425d-902a-00eb3e1d6610")]
-  public interface IMultiObjectiveProblemDefinition<TEncoding, TEncodedSolution> : IProblemDefinition<TEncoding, TEncodedSolution>
+  public interface IMultiObjectiveProblemDefinition<TEncoding, TEncodedSolution> : IMultiObjectiveProblemDefinition, IProblemDefinition<TEncoding, TEncodedSolution>
     where TEncoding : class, IEncoding<TEncodedSolution>
     where TEncodedSolution : class, IEncodedSolution {
-
-    int Objectives { get; }
-    bool[] Maximization { get; }
     double[] Evaluate(TEncodedSolution solution, IRandom random);
     void Analyze(TEncodedSolution[] solutions, double[][] qualities, ResultCollection results, IRandom random);
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/ISingleObjectiveProblem.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/ISingleObjectiveProblem.cs	(revision 17224)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/ISingleObjectiveProblem.cs	(revision 17225)
@@ -1,4 +1,3 @@
 ﻿#region License Information
-
 /* HeuristicLab
  * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
@@ -19,13 +18,14 @@
  * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
  */
-
 #endregion
 
 
 namespace HeuristicLab.Optimization {
-  public interface ISingleObjectiveProblem<TEncoding, TEncodedSolution> : IProblem<TEncoding, TEncodedSolution>, ISingleObjectiveHeuristicOptimizationProblem
-    where TEncoding : class, IEncoding<TEncodedSolution>
-    where TEncodedSolution : class, IEncodedSolution {
+  public interface ISingleObjectiveProblem : ISingleObjectiveHeuristicOptimizationProblem {
 
   }
+
+  public interface ISingleObjectiveProblem<TEncoding, TEncodedSolution> : ISingleObjectiveProblem, IProblem<TEncoding, TEncodedSolution>
+    where TEncoding : class, IEncoding<TEncodedSolution>
+    where TEncodedSolution : class, IEncodedSolution { }
 }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/ISingleObjectiveProblemDefinition.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/ISingleObjectiveProblemDefinition.cs	(revision 17224)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/ISingleObjectiveProblemDefinition.cs	(revision 17225)
@@ -25,13 +25,16 @@
 
 namespace HeuristicLab.Optimization {
+  public interface ISingleObjectiveProblemDefinition {
+    bool Maximization { get; }
+    bool IsBetter(double quality, double bestQuality);
+  }
+
   [StorableType("7ec7bf7e-aaa7-4681-828b-3401cf67e2b3")]
-  public interface ISingleObjectiveProblemDefinition<TEncoding, TEncodedSolution> : IProblemDefinition<TEncoding, TEncodedSolution>
+  public interface ISingleObjectiveProblemDefinition<TEncoding, TEncodedSolution> : ISingleObjectiveProblemDefinition, IProblemDefinition<TEncoding, TEncodedSolution>
     where TEncoding : class, IEncoding<TEncodedSolution>
     where TEncodedSolution : class, IEncodedSolution {
-    bool Maximization { get; }
     double Evaluate(TEncodedSolution solution, IRandom random);
     void Analyze(TEncodedSolution[] solutions, double[] qualities, ResultCollection results, IRandom random);
     IEnumerable<TEncodedSolution> GetNeighbors(TEncodedSolution solution, IRandom random);
-    bool IsBetter(double quality, double bestQuality);
   }
 }
